#version 120

/*
.
Crapdeshoes’ , derived from Chocapic13
Place two leading Slashes in front of the following '#define' lines in order to disable an option.
.
*/

//---Waving Effects---//

//#define WAVING_GRASS
//#define WAVING_FLOWERS
//#define WAVING_VEGETATION
#define WAVING_LEAVES
//#define WAVING_LILIES
//#define WAVING_VINES
//#define WAVING_SAPLINGS
//#define WAVING_SUGAR_CANES
//#define WAVING_TALLPLANTS_&_TALLGRASS

//#define WAVING_FIRE
//#define WAVING_LAVA
//#define WAVING_WATER

//---Waving Effects---//

const float PI = 3.1415927;

varying vec4 color;
varying vec2 lmcoord;
varying float translucent;
varying vec2 texcoord;
varying vec3 normal;

attribute vec4 mc_Entity;
attribute vec4 mc_midTexCoord;

uniform vec3 cameraPosition;
uniform mat4 gbufferModelView;
uniform mat4 gbufferModelViewInverse;
uniform int worldTime;
uniform float frameTimeCounter;
uniform float rainStrength;

void main() {
	
	texcoord = (gl_TextureMatrix[0] * gl_MultiTexCoord0).st;
	vec2 midcoord = (gl_TextureMatrix[0] *  mc_midTexCoord).st;
	translucent = 0.0f;
	float istopv = 0.0;
	
	if (gl_MultiTexCoord0.t < mc_midTexCoord.t) istopv = 1.0;
	/* un-rotate */
	vec4 position = gl_Vertex;
	vec3 worldpos = position.xyz + cameraPosition;
	
	//initialize per-entity waving parameters
	float parm0,parm1,parm2,parm3,parm4,parm5 = 0.0;
	vec3 ampl1,ampl2;
	ampl1 = vec3(0.0);
	ampl2 = vec3(0.0);
	
	float speed = 0.1;
        float magnitude = (sin((frameTimeCounter * 3.14159265358979323846264 / ((28.0) * speed))) * 0.05 + 0.15) * 0.27;
        float d2 = sin(frameTimeCounter * 3.14159265358979323846264 / (162.0 * speed)) * 3.0 - 1.5;
        float d3 = sin(frameTimeCounter * 3.14159265358979323846264 / (112.0 * speed)) * 3.0 - 1.5;

   #ifdef WAVING_LEAVES
	if (mc_Entity.x == 18.0) {
	position.x += sin(position.z+float(frameTimeCounter)/1.25)*0.1*(rainStrength+1)-0.05*(rainStrength+1);
	position.z += sin(position.x+float(frameTimeCounter)/1.25)*0.1*(rainStrength+1)-0.05*(rainStrength+1);
	translucent = 1.0;
	}
#endif

    #ifdef WAVING_LILIES
    if (mc_Entity.x == 111.0) {
        position.x += sin(position.z+float(frameTimeCounter)/1.25)*0.1*(rainStrength+1)-0.05*(rainStrength+1);
	position.z += sin(position.x+float(frameTimeCounter)/1.25)*0.1*(rainStrength+1)-0.05*(rainStrength+1);
	translucent = 1.0;
    }
    #endif
 
    #ifdef WAVING_VINES
    if (mc_Entity.x == 106.0) {
        position.x += sin(position.z+float(frameTimeCounter)/2.0)*0.1*(rainStrength+1)-0.05*(rainStrength+1);
	position.z += sin(position.x+float(frameTimeCounter)/2.0)*0.1*(rainStrength+1)-0.05*(rainStrength+1);
	translucent = 1.0;
    }
    #endif

    #ifdef WAVING_SUGAR_CANES
    if (mc_Entity.x == 83.0 && texcoord.t < 1.90 && texcoord.t > -1.0) {
        position.x += sin(position.z+float(frameTimeCounter)/3.25)*0.1*(rainStrength+1)-0.05*(rainStrength+1);
	position.z += sin(position.x+float(frameTimeCounter)/3.25)*0.1*(rainStrength+1)-0.05*(rainStrength+1);
	translucent = 1.0;
    }
    #endif

	if (istopv > 0.9) {

   #ifdef WAVING_GRASS
    if (mc_Entity.x == 31.0) {
        position.x += sin(position.z+frameTimeCounter*1.5)*0.1*(rainStrength+1)-0.05*(rainStrength+1);
	position.z += sin(position.x+frameTimeCounter*1.5)*0.1*(rainStrength+1)-0.05*(rainStrength+1);
	translucent = 1.0;
    }
    #endif

    if (mc_Entity.x == 31.0) translucent = 1.0;

   #ifdef WAVING_SAPLINGS
    if (mc_Entity.x == 6) {
        position.x += sin(position.z+frameTimeCounter*2.25)*0.1*(rainStrength+1)-0.05*(rainStrength+1);
	position.z += sin(position.x+frameTimeCounter*2.25)*0.1*(rainStrength+1)-0.05*(rainStrength+1);
	translucent = 1.0;
    }
    #endif

   #ifdef WAVING_TALLPLANTS_&_TALLGRASS
    if ( mc_Entity.x == 175.0 && texcoord.t < 0.23) {
        position.x += sin(position.z+frameTimeCounter*1.5)*0.1*(rainStrength+1)-0.05*(rainStrength+1);
	position.z += sin(position.x+frameTimeCounter*1.5)*0.1*(rainStrength+1)-0.05*(rainStrength+1);
	translucent = 1.0;
    }
    #endif
    
    #ifdef WAVING_FLOWERS
    if (mc_Entity.x == 37.0 || mc_Entity.x == 38.0) {
       position.x += sin(position.z+frameTimeCounter*1.75)*0.1*(rainStrength+1)-0.05*(rainStrength+1);
	position.z += sin(position.x+frameTimeCounter*1.75)*0.1*(rainStrength+1)-0.05*(rainStrength+1);
	translucent = 1.0;
    }
    #endif
    
    #ifdef WAVING_VEGETATION
    if (mc_Entity.x == 59.0 || mc_Entity.x == 141 || mc_Entity.x == 142) {
        position.x += sin(position.z+frameTimeCounter*2.0)*0.1*(rainStrength+1)-0.05*(rainStrength+1);
	position.z += sin(position.x+frameTimeCounter*2.0)*0.1*(rainStrength+1)-0.05*(rainStrength+1);
	translucent = 1.0;
    }
    #endif
    
    #ifdef WAVING_FIRE
    if (mc_Entity.x == 51.0 && texcoord.t < 0.10) {
        position.x += sin(position.z+frameTimeCounter*2.0)*0.1*(rainStrength+1)-0.05*(rainStrength+1);
	position.z += sin(position.x+frameTimeCounter*2.0)*0.1*(rainStrength+1)-0.05*(rainStrength+1);
	translucent = 1.0;
    }
    #endif
   
	}

	/* re-rotate */
	
	/* projectify */
	gl_Position = gl_ProjectionMatrix * (gl_ModelViewMatrix * position);
	
	color = gl_Color;
	
	lmcoord = (gl_TextureMatrix[1] * gl_MultiTexCoord1).xy;
	
	normal = normalize(gl_NormalMatrix * gl_Normal);
}